﻿Type=Activity
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen:  True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim MaxI As Int = 0
	Dim Task As Int = 0
	Dim mTsk As Int = 0
	Dim iTsk As Int = 0

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private CL4 As AppPreference
	Private AsyncDownloader As RSAsyncDownloader

	Private Label1 As Label
	Private Label2 As Label
	Private Panel1 As Panel

	Private btnOK As Button
	Private ProgressBar1 As ProgressBar
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("preference")
	Label1.Text = Maps.L(1,"    ● Settings application")
	
	CL4.Initialize(Me, "CL4")
	Activity.AddView(CL4.AsView, 0dip, 22dip, 100%x, 100%y-22dip)
	
	Panel1.Visible = False
	Panel1.BringToFront

	Maps.AppPM.INP_Name.AddAll(Array As String(Maps.L(2,"English"),Maps.L(12,"( unknown... )")))
	Maps.AppPM.MTL_Name.AddAll(Array As String(Maps.L(2,"English"),Maps.L(3,"French"),Maps.L(4,"German"),Maps.L(5,"Hebraic"),Maps.L(6,"Italian"),Maps.L(7,"Japanese"),Maps.L(8,"Polish"),Maps.L(9,"Russian"),Maps.L(10,"Slovak"),Maps.L(11,"Spanish")))

	Maps.AppPM.Items("#01."&Maps.L(13,"Download File"),Maps.L(14,"Download traineddata:")&CRLF&"https://github.com/tesseract-ocr/tessdata"&"®"&Maps.L(14,"Download traineddata:")&CRLF&"https://github.com/tesseract-ocr/tessdata",False,0,True)
	Maps.AppPM.Items("#02."&Maps.L(15,"Choose Language"),Maps.L(16,"Select a language from the available list")&"®"&Maps.L(16,"Select a language from the available list"),False,0,True)
	Maps.AppPM.Items("#03."&Maps.L(17,"Default setting"),Maps.L(18,"The removal of the current settings and restore the default settings when you restart the application")&"®"&Maps.L(18,"The removal of the current settings and restore the default settings when you restart the application"),False,0,True)
	Maps.AppPM.Items("#04."&Maps.L(19,"Prefix name"),Maps.L(20,"The prefix name for the created images")&"®"&Maps.L(20,"The prefix name for the created images"),False,0,True)
	Maps.AppPM.Items("#05."&Maps.L(21,"Change password"),Maps.L(22,"Settings are disabled")&"®"&Maps.L(23,"Settings are enabled"),False,0,Maps.AppPM.accessed.GetValueAt(4))
	Maps.AppPM.Items("#06."&Maps.L(24,"Unknown sources"),Maps.L(25,"Allow installation of applications from sources other than shop Play")&"®"&Maps.L(25,"Allow installation of applications from sources other than shop Play"),False,0,True)
	Maps.AppPM.Items("#07."&Maps.L(26,"Shop Play"),Maps.L(27,"Shop Play settings are disabled")&"®"&Maps.L(28,"Shop Play settings are enabled"),False,5,True)
	Maps.AppPM.Items("#08."&Maps.L(29,"Choose Language"),Maps.L(30,"Language settings are disabled")&"®"&Maps.L(31,"Language settings are enabled"),False,1,True)
	Maps.AppPM.Items("#09."&Maps.L(32,"Flash ON"),Maps.L(22,"Settings are disabled")&"®"&Maps.L(23,"Settings are enabled"),True,0,True)
	Maps.AppPM.Items("#0A."&Maps.L(33,"Focus AUTO"),Maps.L(22,"Settings are disabled")&"®"&Maps.L(23,"Settings are enabled"),True,0,True)
	
	MaxI = Maps.AppPM.CST_Name.Size - 1

	If MaxI <= 0 Then Return
	
	For i = 0 To MaxI
		Select i
		  Case 0,1,2,3,4
		  	Maps.AppPM.enableds.Put(Maps.AppPM.CST_Name.GetKeyAt(i),True)
		  Case 5
		  	Maps.AppPM.enableds.Put(Maps.AppPM.CST_Name.GetKeyAt(i),False)
		  Case 6	'enabled 5 - unknown sources
		  	Maps.AppPM.enableds.Put(Maps.AppPM.CST_Name.GetKeyAt(i),5)	'TRUE - Allow only on first installation
		  Case 7	'enabled 1 - choose language
		  	Maps.AppPM.enableds.Put(Maps.AppPM.CST_Name.GetKeyAt(i),1)
		  Case Else
		  	Maps.AppPM.enableds.Put(Maps.AppPM.CST_Name.GetKeyAt(i),True)
		End Select
	Next

	For i = 0 To MaxI
		Select i
		  Case 0,1,2,3,4,5
		  	If i = 0 Then CL4.AddHeader(Maps.L(34,"Installation and running"),i)
			CL4.Add(CreateListItem(Maps.AppPM.CST_Name.GetKeyAt(i), Maps.AppPM.CST_Name.GetValueAt(i), i, False, CL4.AsView.Width - 10dip, 50dip),80dip, Maps.AppPM.CST_Name.GetKeyAt(i))
		  Case Else
		  	If i = 6 Then CL4.AddHeader(Maps.L(35,"Group Settings"),i)
			CL4.Add(CreateListItem(Maps.AppPM.CST_Name.GetKeyAt(i), Maps.AppPM.CST_Name.GetValueAt(i), i, True, 245dip, 50dip), 80dip, i)
		End Select
	Next
End Sub

Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		CL4.Clear
	End If
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	Select KeyCode
	  Case KeyCodes.KEYCODE_BACK
	  	Try
			If Panel1.Visible Then 
				Return True
			End If
	  		File.WriteMap(File.DirInternal, "settings.cfg", Maps.AppPM.settings)
			File.WriteMap(File.DirInternal, "accessed.cfg", Maps.AppPM.accessed)
		Catch
			Msgbox(LastException.Message, Maps.L(0,"A T T E N T I O N"))
		End Try
		Activity.Finish
	  Case Else
	  	Activity.OpenMenu
	End Select
	Return False
End Sub

#Region  - *** EventHandler CL4 - 
Sub CL4_ItemClick(Index As Int, Value As Object)
	If Maps.AppPM.settings.Size = 0 Or Panel1.Visible Then
		Return
	Else
		If Maps.AppPM.accessed.ContainsKey("#0"&Index) Then
	  		If Maps.AppPM.accessed.Get("#0"&Index) = False Then Return
		End If
	End If
	Select Index
	  Case 0	'___ **************************************************** #1: Download English, ...,
	  	Private MTL As Map
		MTL.Initialize
		For i = 0 To 9
			MTL.Put(Maps.AppPM.MTL_Name.Get(i), Maps.AppPM.settings.Get("#0"&i))
		Next
		InputMap (MTL, Value)
    	If MTL.Size > 0 Then
			Private isTrue As Boolean = False
    		For i = 0 To MTL.Size - 1
				Private Key As String = "#0"&i
				Private oValue As Boolean = MTL.Get(Maps.AppPM.MTL_Name.Get(i))
        		Maps.AppPM.settings.Put(Key, oValue) ' MTL = true/false
				If isTrue = False And oValue = True Then isTrue = True
    		Next
			If isTrue Then
				Private res As Int
				res = Msgbox2(Maps.L(36,"Do you begin now to download files from the Internet?"), Maps.L(37,"Internet"), Maps.L(38,"YES"), Maps.L(39,"Cancel"),"", Null)
				If res = DialogResponse.POSITIVE Then StartDownload
			End If
		End If
	  Case 1	'___ ***************************************************** #2: Set Language (0-English,1-( unknown... ))
    	Private List1 As List
    	List1.Initialize
    	For i = 0 To 1
        	List1.Add(Maps.AppPM.INP_Name.Get(i))
    	Next
    	Private result_IL As Int = 0
    	result_IL = InputList(List1, Value, Maps.AppPM.settings.Get("#10"))
		If result_IL > -1 Then
			Maps.AppPM.settings.Put("#10", result_IL)
			ProgressDialogShow2(Maps.L(40,"Please waiting ..."), True)
			If Maps.ReadLanguage = True Then CallSubDelayed(Main, "RefreshLanguage")
	  		Try
	  			File.WriteMap(File.DirInternal, "settings.cfg", Maps.AppPM.settings)
				File.WriteMap(File.DirInternal, "accessed.cfg", Maps.AppPM.accessed)
			Catch
				Msgbox(LastException.Message, Maps.L(0,"A T T E N T I O N"))
			End Try
			Activity.Finish
		End If
	  Case 2	'___ ***************************************************** #3: MsgBox(no-cancel-YES)
	  	Private ret As Int
		ret = Msgbox2(Maps.L(41,"Do you want to restore default settings?"), Value, Maps.L(38,"YES"),Maps.L(39,"Cancel"),Maps.L(42,"No"), Null)
		Select ret
		  Case DialogResponse.CANCEL
		  	'Cancel action!
		  Case DialogResponse.NEGATIVE
		  	Maps.AppPM.settings.Put("#"&(MaxI+Index), False)
		  Case DialogResponse.POSITIVE
		  	Maps.AppPM.settings.Put("#"&(MaxI+Index), True)
		End Select
	  Case 3	'___ ***************************************************** #4: InputDialog(edittext)
   		Private Id As InputDialog
		Private kb As IME
		kb.Initialize("kb")
   		Id.Hint = "TESS yyyy-mm-dd HH:mm"
   		Id.HintColor = Colors.DarkGray
   		Id.InputType = Id.INPUT_TYPE_TEXT
   		Id.Input = Maps.AppPM.settings.Get("#"&(MaxI+Index))
		Id.PasswordMode = False
		kb.ShowKeyboard(Activity)
   		ret = DialogResponse.CANCEL
   		ret = Id.Show(Maps.L(43,"Input Name:"), Value, Maps.L(44,"Accept"), Maps.L(39,"Cancel"), "", Null)
   		If ret = DialogResponse.POSITIVE Then
			Private set As String = Id.Input
			If set.Length > 4 Then
				set = set.SubString2(0,4).ToUpperCase
			End If
			Maps.AppPM.settings.Put("#"&(MaxI+Index), set)
   		End If
		kb.HideKeyboard
	  Case 4	'___ ***************************************************** #5: Change password(cancel-change&save password)
    	Private  pp As Panel 
    	Private lb1 As Label 
    	Private lb2 As Label
	   	Private old_password As EditText 
   		Private new_password As EditText 
    
    	pp.Initialize("")
		pp.Color = Colors.White
    	old_password.Initialize("old_password")
    	new_password.Initialize("new_password")
    	lb1.Initialize("")
    	lb2.Initialize("")
   
    	old_password.SingleLine   = True
    	new_password.SingleLine   = True
		old_password.PasswordMode = True
    	new_password.PasswordMode = True
    
    	Private cd As CustomDialog 
    
    	cd.AddView(pp,0dip,0,90%x-4dip,190dip)
    	pp.AddView(old_password,40dip,50dip,pp.Width-80dip,48dip)
    	pp.AddView(new_password,40dip,120dip,pp.Width-80dip,48dip)
    	pp.AddView(lb1,40dip,30dip,pp.Width-80dip,40dip)
    	pp.AddView(lb2,40dip,100dip,pp.Width-80dip,40dip)

		Private kb As IME
		kb.Initialize("")
		
		lb1.TextColor = Colors.Black
		lb2.TextColor = Colors.Black
		old_password.TextColor = Colors.Black
		new_password.TextColor = Colors.Black
    	old_password.Hint = ""
    	new_password.Hint = ""
    	lb1.Text = Maps.L(45,"Enter old password:")
    	lb2.Text = Maps.L(46,"Enter new password:")
      	old_password.Text = ""
		old_password.RequestFocus
		kb.ShowKeyboard(old_password)
   		cd.Show(Maps.L(47,"Change password"),Maps.L(48,"Change & Save password"),Maps.L(39,"Cancel"),"",Null)
    	lb1.RequestFocus 
		kb.HideKeyboard

    	Select cd.Response
		  Case DialogResponse.CANCEL
			Return
   		  Case DialogResponse.POSITIVE
		  	Private comp As String = Maps.AppPM.settings.Get("#"&(MaxI+Index))
			If comp.Length > 0 Then
				If old_password.Text.CompareTo(Crypto.Decrypt(comp)) <> 0 Then
					Msgbox(Maps.L(49,"Entered password you entered")&CRLF&Maps.L(50,"is incorrect!"), Maps.L(51,"Compare password"))
					Return
				End If
			End If
		  	If new_password.Text.Length >= 4 Then
		  		Maps.AppPM.settings.Put("#"&(MaxI+Index), Crypto.Encrypt(new_password.Text))
        		ToastMessageShow(Maps.L(52,"Password has bee saved."),True)
			Else
				Msgbox(Maps.L(53,"Password not saved!"),Maps.L(0,"A T T E N T I O N"))
			End If
		End Select
	  Case 5	'___ ***************************************************** #6: Unknown sources(allow-cancel-OK)
    	Private  pp As Panel 
    	Private lb1 As Label 
    	Private cb1 As CheckBox
    
    	pp.Initialize("")
		pp.Color = Colors.White
    	lb1.Initialize("")
    	cb1.Initialize("cb1")
       
    	Private cd As CustomDialog 
    
    	cd.AddView(pp,0dip,0,90%x-4dip,190dip)
    	pp.AddView(lb1,18dip,10dip,pp.Width-10dip,100dip)
    	pp.AddView(cb1,10dip,130dip,pp.Width-10dip,40dip)

		cb1.Checked = False
		lb1.TextColor = Colors.Black
		cb1.TextColor = Colors.Black
		lb1.TextSize = 14
    	lb1.Text = Maps.L(54,"The device and personal data are particularly unverable to attack by applications from unknown sources.")
    	cb1.Text = Maps.L(55,"Allow only on first installation")
   		cd.Show(Maps.L(56,"Safety"),"OK","",Maps.L(39,"Cancel"),Null)

    	Select cd.Response
   		  Case DialogResponse.POSITIVE
	  		Maps.AppPM.settings.Put("#"&(MaxI+Index), Not(cb1.Checked))	'___ ********* #14
		  	Maps.AppPM.enableds.Put(Maps.AppPM.CST_Name.GetKeyAt(Index), cb1.Checked)
		  Case Else
		  	'no action!
		End Select
	  Case Else			'___ ***************************************************** #7: More elements
	  	Select Index
		  Case 6,7		'___ ***************************************************** #7/#8:  ON | OFF (unknown sources), ON | OFF (Language)
		  Case Else		'___ ***************************************************** #9/#A: Checked Flash ON, Checked Focus AUTO
			Private pnl As Panel
			pnl = CL4.GetPanel(Index)
			Private chk As CheckBox
			chk = pnl.GetView(2)
			chk.checked = Not(chk.checked)
			Maps.AppPM.settings.Put("#"&(MaxI+Index), chk.checked)
		End Select
	End Select
End Sub
Sub CreateListItem(Key As String, Title As String, Index As Int, isCheckBox As Boolean, Width As Int, Height As Int) As Panel
	Private p As Panel
	p.Initialize("")
	p.Color = Colors.White
	
#Region  - *** AddLabels CL4 -
	Private lb0,lb1 As Label
	Private ColorBlack As Int = Colors.Black
	
	Private words() As String
	words = Regex.Split("®", Title)

	lb0.Initialize("")
	lb1.Initialize("")
	lb0.Gravity = Bit.Or(Gravity.TOP, Gravity.LEFT)
	lb1.Gravity = Bit.Or(Gravity.BOTTOM, Gravity.LEFT)
	lb0.Text = Key
	lb0.TextSize = 18
	lb0.TextColor = ColorBlack
	lb0.Typeface = Typeface.LoadFromAssets("arimo.ttf")
	lb1.Text = words(1)
	lb1.TextSize = 14
	lb1.TextColor = ColorBlack
	lb1.Typeface = Typeface.LoadFromAssets("roboto.ttf")
	p.AddView(lb0, 10dip,  5dip, Width, Height - 4dip)	'view #0
	p.AddView(lb1, 10dip, 22dip, Width, Height - 4dip)
	#End Region

	If isCheckBox Then
		Select Index
	  	  Case 6,7
#Region  - *** AddSwitchView CL4 -
			Private sw As AppSwitch
			sw.Initialize(Me, "sw")
			sw.TextOff = "OFF"
			sw.TextOn = "ON"
			sw.switch.Tag = Index
			p.AddView(sw.switch, 250dip, 2dip, 100dip, Height - 4dip) 	'view #2
			sw.Checked = Maps.AppPM.settings.Get("#"&(MaxI+Index))
			If Index = 6 Then
				If Maps.AppPM.GetAndroidUnknownSourceStatus = 0 Then
					sw.Checked = False
				Else
					sw.Checked = True
				End If
			End If
			If Not(sw.Checked) Then
				ColorBlack = Colors.Gray
				lb0.TextColor = ColorBlack
				lb1.TextColor = ColorBlack
				lb1.Text = words(0)
			End If
			AccessItems(Maps.AppPM.CST_Name.GetKeyAt(Index), sw.Checked)
			#End Region
	  	  Case Else
#Region  - *** AddCheckBox CL4 -
			Private chk As CheckBox
			chk.Initialize("chk")
			p.AddView(chk, 300dip, 5dip, 50dip, Height - 4dip) 			'view #2
			chk.checked = Maps.AppPM.settings.Get("#"&(MaxI+Index))
			If Not(chk.checked) Then
				ColorBlack = Colors.Gray
				lb0.TextColor = ColorBlack
				lb1.TextColor = ColorBlack
				lb1.Text = words(0)
			End If
			#End Region
		End Select
	End If
	Return p
End Sub
Sub chk_CheckedChange(checked As Boolean)
	Private Index As Int
	Index = CL4.GetItemFromView(Sender)
	Private pnl As Panel
	Private chk As CheckBox
	pnl = CL4.GetPanel(Index)
	chk = pnl.GetView(2)
	If Panel1.Visible Then
		chk.Checked = Not(checked)
		chk.Invalidate
		Return
	End If
	Maps.AppPM.settings.Put("#"&(MaxI+Index), chk.checked)
	
	' Remove all items
	For i = 0 To pnl.NumberOfViews - 1
		pnl.RemoveViewAt(0)
	Next

	Private lb0 As Label
	Private lb1 As Label
	Private ColorBlack As Int
	lb0.Initialize("")
	lb1.Initialize("")
	
	Private words() As String
	words = Regex.Split("®", Maps.AppPM.CST_Name.GetValueAt(Index))

	If Maps.AppPM.settings.Get("#"&(MaxI+Index)) Then 
		lb0.Text = Maps.AppPM.CST_Name.GetKeyAt(Index)
		lb1.Text = words(1): ColorBlack = Colors.Black
	Else
		lb0.Text = Maps.AppPM.CST_Name.GetKeyAt(Index)
		lb1.Text = words(0): ColorBlack = Colors.Gray
	End If
	lb0.Gravity = Bit.Or(Gravity.TOP, Gravity.LEFT)
	lb1.Gravity = Bit.Or(Gravity.BOTTOM, Gravity.LEFT)
	lb0.TextSize = 18
	lb0.TextColor = ColorBlack
	lb0.Typeface = Typeface.LoadFromAssets("arimo.ttf")
	lb1.TextSize = 14
	lb1.TextColor = ColorBlack
	lb1.Typeface = Typeface.LoadFromAssets("roboto.ttf")
	pnl.AddView(lb0, 10dip,  5dip, 245dip, 50dip - 4dip)	'view #0
	pnl.AddView(lb1, 10dip, 22dip, 245dip, 50dip - 4dip)	'view #1
	pnl.AddView(chk, 300dip, 5dip,  50dip, 50dip - 4dip)	'view #2
	pnl.Invalidate
	'
'	ToastMessageShow(CL4.GetValue(index) & CRLF & chk.Checked, False)
End Sub
Sub sw_CheckedChange(checked As Boolean, Index As Int)
	Private pnl As Panel
	pnl = CL4.GetPanel(Index)
	If Panel1.Visible Then
		Dim s_view As AppSwitch = Sender
		s_view.Checked = Not(checked)
		Return
	End If
	Maps.AppPM.settings.Put("#"&(MaxI+Index), checked)
	
	Private ColorBlack As Int = Colors.Black
	If Not(checked) Then ColorBlack = Colors.Gray
	Private lb0 As Label
	Private lb1 As Label
	lb0.Initialize("")
	lb1.Initialize("")
	lb0 = pnl.GetView(0)
	lb1 = pnl.GetView(1)
	lb0.Gravity = Bit.Or(Gravity.TOP, Gravity.LEFT)
	lb1.Gravity = Bit.Or(Gravity.BOTTOM, Gravity.LEFT)
	lb0.TextSize = 18
	lb0.TextColor = ColorBlack
	lb0.Typeface = Typeface.LoadFromAssets("arimo.ttf")
	lb1.TextSize = 14
	lb1.TextColor = ColorBlack
	lb1.Typeface = Typeface.LoadFromAssets("roboto.ttf")
	
	Private words() As String
	words = Regex.Split("®", Maps.AppPM.CST_Name.GetValueAt(Index))

	If Maps.AppPM.settings.Get("#"&(MaxI+Index)) Then 
		lb0.Text = Maps.AppPM.CST_Name.GetKeyAt(Index)
		lb1.Text = words(1)
	Else
		lb0.Text = Maps.AppPM.CST_Name.GetKeyAt(Index)
		lb1.Text = words(0)
	End If
	pnl.Invalidate
	AccessItems(Maps.AppPM.CST_Name.GetKeyAt(Index), checked)
	'
	If checked And Index = 6 Then
		Dim DoAction As Intent
		DoAction.Initialize("android.settings.SECURITY_SETTINGS", "")
		StartActivity(DoAction)
	End If
	'
'	ToastMessageShow(CL4.GetValue(index) & CRLF & Checked, False)
End Sub
Sub AccessItems(Title As String, SetValue As Boolean)
	Private words() As String
	words = Regex.Split(",", Maps.AppPM.enableds.Get(Title))
	If words.Length > 0 Then
		Private pnl As Panel
		Private lb0 As Label
		Private lb1 As Label
		lb0.Initialize("")
		lb1.Initialize("")
		Private ColorBlack As Int = Colors.Black
		If Not(SetValue) Then ColorBlack = Colors.Gray
		For i = 0 To words.Length - 1
			pnl = CL4.GetPanel(words(i))
			lb0 = pnl.GetView(0)
			lb1 = pnl.GetView(1)
			lb0.TextColor = ColorBlack
			lb1.TextColor = ColorBlack
			pnl.Invalidate
			Maps.AppPM.accessed.Put("#0"&words(i), SetValue)
		Next
	End If
End Sub
#End Region

#Region  - *** Downloader - 

Sub StartDownload As Boolean
	Private extension As String
	
	Try
		Task = 0
		mTsk = 0
		iTsk = 0

		For i = 0 To 9
			AsyncDownloader.Initialize("AsyncDownloader")
			Private Key As String = "#0"&i
			Select i
		 	  Case 0
		  		extension = "eng"
		  	  Case 1
		  		extension = "fra"
		  	  Case 2
		  		extension = "deu"
		  	  Case 3
		  		extension = "heb"
		  	  Case 4
		  		extension = "ita"
		  	  Case 5
		  		extension = "jpn"
		  	  Case 6
		  		extension = "pol"
		  	  Case 7
		  		extension = "rus"
		  	  Case 8
		  		extension = "slk"
		  	  Case 9
		  		extension = "spa"
			End Select
        	If Maps.AppPM.settings.Get(Key) = True Then ' true/false
				'Download file(s):
				Task = Task + 1
				mTsk = Task
				AsyncDownloader.FileName = extension & ".traineddata"
    			AsyncDownloader.Directory = Main.tessDataPath
    			AsyncDownloader.Download("https://github.com/tesseract-ocr/tessdata/raw/master/" & extension & ".traineddata")
			End If
		Next
		Return True
	Catch
		Panel1.Visible = False
		If AsyncDownloader.IsInitialized Then AsyncDownloader.Cancel(True)
		Msgbox(LastException.Message, Maps.L(0,"A T T E N T I O N"))
		Return False
	End Try
End Sub

Private Sub AsyncDownloader_Started
	Panel1.Visible = True
	ProgressBar1.Indeterminate = False
	Label1.Text = Maps.L(57,"The download has started.")
End Sub

Private Sub AsyncDownloader_Update (Progress As Int)
	Label1.Text = "("&Progress&")." & AsyncDownloader.FileName
End Sub

Private Sub AsyncDownloader_Finished (Result As String)
	Task = Task - 1
	iTsk = iTsk + 1
	If Task > 0 Then 
		ProgressBar1.progress=Round((iTsk * 100) / mTsk)
		Label1.Text = AsyncDownloader.FileName
	Else
		ProgressBar1.Indeterminate = True
		Label1.Text = Maps.L(58,"The download has finished.")
		btnOK.Enabled = True
	End If
End Sub

Sub btnOK_Click
	btnOK.Enabled  = False
	Panel1.Visible = False
End Sub
#End Region